<?php
/* Joe Presbrey <presbrey@mit.edu>
 * 2007/07/25
 */
require_once('_util.php');

if (stristr(get_request_subpath(), '..')) die('Invalid path.');
$request_fullpath = DATA_PATH.DIRECTORY_SEPARATOR.get_request_subpath();
$proof_fullpath = DATA_PATH.DIRECTORY_SEPARATOR.'meta'.DIRECTORY_SEPARATOR.get_request_subpath();
if (($request_realpath = realpath($request_fullpath))!==FALSE) {
    $request_realdir = dirname($request_realpath);
    if (DATA_PATH == substr($request_realdir, 0, strlen(DATA_PATH))) {
        $data_file = $request_realdir.DIRECTORY_SEPARATOR.basename($request_fullpath);
        $ext = array_pop(explode('.',basename($data_file)));
	if (!strpos($_SERVER['HTTP_ACCEPT'], 'n3') || !file_exists($proof_fullpath)){ //If the client doesn't accept n3, don't give it the proof
        if (file_exists($data_file)) {
	  if ($ext=='n3')
	    header('Content-Type: text/rdf+n3');
	  else
            header('Content-Type: application/rdf+xml');
	  header('MS-Author-Via: SPARQL');
	  readfile($data_file);
	  exit;
        }// else die('File not found.');
	}
	else{
	  //proof exists, output N3
	  //$bin_algae = '/afs/csail.mit.edu/group/dig/www/bin/algae';
	  $bin_cwm = '/afs/csail.mit.edu/group/dig/www/data/TAMI/2007/cwmrete/cwm';
	  //Being frustrated by algae, I decided to use cwm
	  $tmp_data_output = tempnam('/tmp','.sparql');
	  $tmp_error_output = tempnam('/tmp','.sparql');
	  //$bin_exe ="$bin_algae -d $data_file --sClass n3 --dump-default >$tmp_data_output 2>$tmp_error_output";
	  $bin_exe ="$bin_cwm --rdf $data_file --n3 >$tmp_data_output 2>$tmp_error_output";
	  `$bin_exe`;
	  if (!filesize($tmp_error_output)) {
	    header('MS-Author-Via: SPARQL');
	    header('Content-Type: text/rdf+n3');
	    readfile($tmp_data_output);
	    readfile($proof_fullpath);	    
	  } else {
	    //exit;
	    header('HTTP/1.1 500 Internal Server Error');
	    readfile($tmp_error_output);
	  }
	  @unlink($tmp_data_output);
	  @unlink($tmp_error_output);
	  exit;
	}
	
    } //else die('Invalid path.');
} //else die('Unwritable path.');
 
header('HTTP/1.1 200 OK');
header('Content-Type: application/rdf+xml');
exit('<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"></rdf:RDF>');
//exit('<html><head><title>404 Not Found</title></head><body><h1>Not Found</h1></body></html>');
